unit eval;

interface

uses param, hash;

type Ev=array[0..127] of shortint;

const
  EKingBW:Ev=  ( 30, 30, 20,-30,-20,-30, 30, 30,  0,  0,  0,  0,  0,  0,  0,  0,
                -10,-10,-20,-40,-40,-25, 0,  10,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0);
  EKingEW:Ev=  (  0,  3,  6,  9,  9,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                  3,  6,  9, 12, 12,  9,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,
                  6,  9, 12, 15, 15, 12,  9,  8,  0,  0,  0,  0,  0,  0,  0,  0,
                  9, 12, 15, 18, 18, 15, 12,  9,  0,  0,  0,  0,  0,  0,  0,  0,
                  9, 12, 15, 18, 18, 15, 12,  9,  0,  0,  0,  0,  0,  0,  0,  0,
                  6,  9, 12, 15, 15, 12,  9,  8,  0,  0,  0,  0,  0,  0,  0,  0,
                  3,  6,  9, 12, 12,  9,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  3,  6,  9,  9,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0);
  EQueenW:Ev=  (  0,  5,  8,  8,  8,  8,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  5, 10, 10, 10, 10,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  5, 10, 10, 10, 10,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                 -2, -5,  5, 15, 15,  5, -5, -2,  0,  0,  0,  0,  0,  0,  0,  0,
                 -5, -5,  5, 15, 15,  5, -5, -5,  0,  0,  0,  0,  0,  0,  0,  0,
                 -5, -5,  5, 15, 15,  5, -5, -5,  0,  0,  0,  0,  0,  0,  0,  0,
                -10, -5,  5,  5,  5,  5, -5,-10,  0,  0,  0,  0,  0,  0,  0,  0,
                -15, -5,  5,  5,  5,  5, -5,-15,  0,  0,  0,  0,  0,  0,  0,  0);
  ERookW:Ev=   (  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0);
  EBishopW:Ev= (  0,-13,-13, -5, -5,-13,-13,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                -10,  6,  0,  0,  0,  0,  6,-10,  0,  0,  0,  0,  0,  0,  0,  0,
                 -5,  0,  5,  0,  0,  5,  0, -5,  0,  0,  0,  0,  0,  0,  0,  0,
                 -5,  0,  5, 10, 10,  5,  0, -5,  0,  0,  0,  0,  0,  0,  0,  0,
                 -5,  0,  5, 10, 10,  5,  0, -5,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  0,  7,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                -10,  5,  0,  0,  0,  0,  5,-10,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,-10, -5, -5, -5, -5, -5,  0,  0,  0,  0,  0,  0,  0,  0,  0);
  EKnightW:Ev= (-45,-14, -8, -8, -8, -8,-14,-45,  0,  0,  0,  0,  0,  0,  0,  0,
                -15,  0,  0,  0,  0,  0,  0,-15,  0,  0,  0,  0,  0,  0,  0,  0,
                -15,  0,  2,  1,  1,  2,  0,-15,  0,  0,  0,  0,  0,  0,  0,  0,
                -15,  0,  7,  7,  7,  7,  0,-15,  0,  0,  0,  0,  0,  0,  0,  0,
                -15,  2, 15, 16, 16, 15,  2,-15,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  5, 19, 24, 24, 19,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                -30,  5,  8,  8,  8,  8,  5,-30,  0,  0,  0,  0,  0,  0,  0,  0,
                -45,  0,  0,  0,  0,  0,  0,-45,  0,  0,  0,  0,  0,  0,  0,  0);
  EPawnW:Ev=   (  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  3,  6,-15,-15,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                  1,  4,  8,  0,  0,  8,  4,  1,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  5, 10, 13, 13, 10,  5,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  3,  6, 12, 15, 15, 12,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,
                 10, 12, 15, 20, 20, 15, 12, 10,  0,  0,  0,  0,  0,  0,  0,  0,
                 15, 18, 26, 30, 30, 26, 18, 15,  0,  0,  0,  0,  0,  0,  0,  0,
                 99, 99, 99, 99, 99, 99, 99, 99,  0,  0,  0,  0,  0,  0,  0,  0);


  EKingBB:Ev=  (-40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -40,-40,-40,-40,-40,-40,-40,-40,  0,  0,  0,  0,  0,  0,  0,  0,
                -10,-10,-20,-40,-40,-25, 0,  10,  0,  0,  0,  0,  0,  0,  0,  0,
                 30, 30, 20,-30,-20,-30, 30, 30,  0,  0,  0,  0,  0,  0,  0,  0);
  EKingEB:Ev=  (  0,  3,  6,  9,  9,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                  3,  6,  9, 12, 12,  9,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,
                  6,  9, 12, 15, 15, 12,  9,  8,  0,  0,  0,  0,  0,  0,  0,  0,
                  9, 12, 15, 18, 18, 15, 12,  9,  0,  0,  0,  0,  0,  0,  0,  0,
                  9, 12, 15, 18, 18, 15, 12,  9,  0,  0,  0,  0,  0,  0,  0,  0,
                  6,  9, 12, 15, 15, 12,  9,  8,  0,  0,  0,  0,  0,  0,  0,  0,
                  3,  6,  9, 12, 12,  9,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  3,  6,  9,  9,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0);
  EQueenB:Ev=  (-15, -5,  5,  5,  5,  5, -5,-15,  0,  0,  0,  0,  0,  0,  0,  0,
                -10, -5,  5,  5,  5,  5, -5,-10,  0,  0,  0,  0,  0,  0,  0,  0,
                 -5, -5,  5, 15, 15,  5, -5, -5,  0,  0,  0,  0,  0,  0,  0,  0,
                 -5, -5,  5, 15, 15,  5, -5, -5,  0,  0,  0,  0,  0,  0,  0,  0,
                 -2, -5,  5, 15, 15,  5, -5, -2,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  5, 10, 10, 10, 10,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  5, 10, 10, 10, 10,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  5,  8,  8,  8,  8,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0);
  ERookB:Ev=   (  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0);
  EBishopB:Ev= (  0,-10, -5, -5, -5, -5, -5,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                -10,  5,  0,  0,  0,  0,  5,-10,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  0,  7,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                 -5,  0,  5, 10, 10,  5,  0, -5,  0,  0,  0,  0,  0,  0,  0,  0,
                 -5,  0,  5, 10, 10,  5,  0, -5,  0,  0,  0,  0,  0,  0,  0,  0,
                 -5,  0,  5,  0,  0,  5,  0, -5,  0,  0,  0,  0,  0,  0,  0,  0,
                -10,  6,  0,  0,  0,  0,  6,-10,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,-13,-13, -5, -5,-13,-13,  0,  0,  0,  0,  0,  0,  0,  0,  0);
  EKnightB:Ev= (-45,  0,  0,  0,  0,  0,  0,-45,  0,  0,  0,  0,  0,  0,  0,  0,
                -30,  5,  8,  8,  8,  8,  5,-30,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  5, 19, 24, 24, 19,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                -15,  2, 15, 16, 16, 15,  2,-15,  0,  0,  0,  0,  0,  0,  0,  0,
                -15,  0,  7,  7,  7,  7,  0,-15,  0,  0,  0,  0,  0,  0,  0,  0,
                -15,  0,  2,  1,  1,  2,  0,-15,  0,  0,  0,  0,  0,  0,  0,  0,
                -15,  0,  0,  0,  0,  0,  0,-15,  0,  0,  0,  0,  0,  0,  0,  0,
                -45,-14, -8, -8, -8, -8,-14,-45,  0,  0,  0,  0,  0,  0,  0,  0);
  EPawnB:Ev=   ( 99, 99, 99, 99, 99, 99, 99, 99,  0,  0,  0,  0,  0,  0,  0,  0,
                 15, 18, 26, 30, 30, 26, 18, 15,  0,  0,  0,  0,  0,  0,  0,  0,
                 10, 12, 15, 20, 20, 15, 12, 10,  0,  0,  0,  0,  0,  0,  0,  0,
                  3,  6, 12, 15, 15, 12,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,
                  2,  5, 10, 13, 13, 10,  5,  2,  0,  0,  0,  0,  0,  0,  0,  0,
                  1,  4,  8,  0,  0,  8,  4,  1,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  3,  6,-15,-15,  6,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0);

  BN_light:Ev=
             (  20, 30, 40, 50, 60, 70, 80,100,  0,  0,  0,  0,  0,  0,  0,  0,   //1
                30, 20, 30, 40, 50, 60, 70, 80,  0,  0,  0,  0,  0,  0,  0,  0,   //2
                40, 30, 20, 30, 40, 50, 60, 70,  0,  0,  0,  0,  0,  0,  0,  0,   //3
                50, 40, 30, 20, 30, 40, 50, 60,  0,  0,  0,  0,  0,  0,  0,  0,   //4
                60, 50, 40, 30, 20, 30, 40, 50,  0,  0,  0,  0,  0,  0,  0,  0,   //5
                70, 60, 50, 40, 30, 20, 30, 40,  0,  0,  0,  0,  0,  0,  0,  0,   //6
                80, 70, 60, 50, 40, 30, 20, 30,  0,  0,  0,  0,  0,  0,  0,  0,   //7
               100, 80, 70, 60, 50, 40, 30, 20,  0,  0,  0,  0,  0,  0,  0,  0);  //8
  BN_dark:Ev=
             ( 100, 80, 70, 60, 50, 40, 30, 20,  0,  0,  0,  0,  0,  0,  0,  0,   //1
                80, 70, 60, 50, 40, 30, 20, 30,  0,  0,  0,  0,  0,  0,  0,  0,   //2
                70, 60, 50, 40, 30, 20, 30, 40,  0,  0,  0,  0,  0,  0,  0,  0,   //3
                60, 50, 40, 30, 20, 30, 40, 50,  0,  0,  0,  0,  0,  0,  0,  0,   //4
                50, 40, 30, 20, 30, 40, 50, 60,  0,  0,  0,  0,  0,  0,  0,  0,   //5
                40, 30, 20, 30, 40, 50, 60, 70,  0,  0,  0,  0,  0,  0,  0,  0,   //6
                30, 20, 30, 40, 50, 60, 70, 80,  0,  0,  0,  0,  0,  0,  0,  0,   //7
                20, 30, 40, 50, 60, 70, 80,100,  0,  0,  0,  0,  0,  0,  0,  0);  //8
  dark_sq:ev=
             (1,0,1,0,1,0,1,0,  0,  0,  0,  0,  0,  0,  0,  0,
              0,1,0,1,0,1,0,1,  0,  0,  0,  0,  0,  0,  0,  0,
              1,0,1,0,1,0,1,0,  0,  0,  0,  0,  0,  0,  0,  0,
              0,1,0,1,0,1,0,1,  0,  0,  0,  0,  0,  0,  0,  0,
              1,0,1,0,1,0,1,0,  0,  0,  0,  0,  0,  0,  0,  0,
              0,1,0,1,0,1,0,1,  0,  0,  0,  0,  0,  0,  0,  0,
              1,0,1,0,1,0,1,0,  0,  0,  0,  0,  0,  0,  0,  0,
              0,1,0,1,0,1,0,1,  0,  0,  0,  0,  0,  0,  0,  0);

// 112,113,114,115,116,117,118,119,  120,121,122,123,124,125,126,127
// 096,097,098,099,100,101,102,103,  104,105,106,107,108,109,110,111
// 080,081,082,083,084,085,086,087,  088,089,090,091,092,093,094,095
// 064,065,066,067,068,069,070,071,  072,073,074,075,076,077,078,079
// 048,049,050,051,052,053,054,055,  056,057,058,059,060,061,062,063
// 032,033,034,035,036,037,038,039,  040,041,042,043,044,045,046,047
// 016,017,018,019,020,021,022,023,  024,025,026,027,028,029,030,031
// 000,001,002,003,004,005,006,007,  008,009,010,011,012,013,014,015

function evalution(ply:byte; alpha,beta:integer):integer;

const
  QueenKo=4;
  KingKo=30;
  TwoBishops=20;
  Shield:array[0..7] of byte=(0,0,10,20,30,35,25,0);
  OpenKing=45;
  TrapRook=50;
  RookKing=8;
  RookQueen=10;
  QueenKing=10;
  RookOn7=30;
  RookOn6=10;
  BishopMobile=2;
  RookMobileV=2;
  RookMobileH=1;
  DoublePawn:array[0..7] of byte=(8,7,6,6,6,6,7,8);
  IsolatePawn:array[0..7] of byte=(13,13,15,17,17,15,13,13);
  PassPawn:array[0..7] of byte=(0,10,20,30,50,70,100,0);

implementation

function evalution(ply:byte; alpha,beta:integer):integer;
var score,matscore,pscore,i{,j},p:integer;
    endgamW,endgamB,safe:boolean;
    wking,bking:byte;
    wqueen,bqueen:byte;
    wrook,brook:byte;
    wbishop,bbishop:byte;
    mob:integer;
    wpawn,bpawn:array[0..7] of byte;
    wpawnmax,wpawnmin,bpawnmax,bpawnmin:array[0..7] of byte;
    wp,bp:byte;
    ind:longint;
    needpawn:boolean;
    kwp,kbp,kwn,kbn,kwb,kbb,kwr,kbr,kwq,kbq:byte;
    wbis,bbis,wfig,bfig:byte;
begin
  matscore:=tree[ply].matw-tree[ply].matb;
  score:=0;
  
  if (beta-alpha=1) and (tree[ply].matw>900) and (tree[ply].matb>900) then
  begin
    if tree[ply].tomove=0 then
    begin
      if (matscore+400<alpha) or (matscore-400>beta) then
      begin
        result:=matscore;
        exit;
      end;
    end else
    begin
      if (-matscore+400<alpha) or (-matscore-400>beta) then
      begin
        result:=-matscore;
        exit;
      end;
    end;
  end;

  endgamW:=true;
  endgamB:=true;

  wking:=tree[ply].wking;
  bking:=tree[ply].bking;
  wqueen:=tree[ply].wqueen;
  bqueen:=tree[ply].bqueen;

  if (bqueen<>255) and (tree[ply].matb>1200) then endgamW:=false;
  if (wqueen<>255) and (tree[ply].matw>1200) then endgamB:=false;

  if tree[ply].matb=0 then dec(score,KingKo*rasst[wking,bking]);
  if tree[ply].matw=0 then inc(score,KingKo*rasst[wking,bking]);

  if endgamW then inc(score,EKingEW[wking])
  else
  begin
    safe:=false;
    inc(score,EKingBW[wking]);
    
    if (wking=0) or (wking=1) then
      if (board[17]=6+64) and ((board[16]=6+64) or (board[32]=6+64)) then safe:=true;
    if (wking=6) or (wking=7) then
      if (board[22]=6+64) and ((board[23]=6+64) or (board[39]=6+64)) then safe:=true;

    if not(safe) then
    begin
      p:=wking+16;
      while (p<104) do
      begin
        if board[p]=6+64 then break;
        p:=p+16;
      end;
      if p>=104 then dec(score,OpenKing)
      else dec(score,shield[p shr 4]);

      if (wking and 7)<>0 then
      begin
        p:=wking+15;
        while (p<104) do
        begin
          if board[p]=6+64 then break;
          p:=p+16;
        end;
        if p>=104 then dec(score,OpenKing)
        else dec(score,shield[p shr 4]);
      end;

      if (wking and 7)<>7 then
      begin
        p:=wking+17;
        while (p<104) do
        begin
          if board[p]=6+64 then break;
          p:=p+16;
        end;
        if p>=104 then dec(score,OpenKing)
        else dec(score,shield[p shr 4]);
      end;
    end;

    if ((wking=5) and ((board[6]=3+64) or (board[7]=3+64))) or
       ((wking=6) and (board[7]=3+64)) then dec(score,TrapRook);
    if ((wking=2) and ((board[1]=3+64) or (board[0]=3+64))) or
       ((wking=1) and (board[0]=3+64)) then dec(score,TrapRook);
  end;

  if endgamB then dec(score,EKingEB[bking])
  else
  begin
    safe:=false;
    dec(score,EKingBB[bking]);

    if (bking=112) or (bking=113) then
      if (board[97]=6+128) and ((board[80]=6+128) or (board[96]=6+128)) then safe:=true;
    if (bking=118) or (bking=119) then
      if (board[102]=6+128) and ((board[87]=6+128) or (board[103]=6+128)) then safe:=true;

    if not(safe) then
    begin
      p:=bking-16;
      while (p>15) do
      begin
        if board[p]=6+128 then break;
        p:=p-16;
      end;
      if p<=15 then inc(score,OpenKing)
      else inc(score,shield[7-(p shr 4)]);

      if (bking and 7)<>0 then
      begin
        p:=bking-17;
        while (p>15) do
        begin
          if board[p]=6+128 then break;
          p:=p-16;
        end;
        if p<=15 then inc(score,OpenKing)
        else inc(score,shield[7-(p shr 4)]);
      end;

      if (bking and 7)<>7 then
      begin
        p:=bking-15;
        while (p>15) do
        begin
          if board[p]=6+128 then break;
          p:=p-16;
        end;
        if p<=15 then inc(score,OpenKing)
        else inc(score,shield[7-(p shr 4)]);
      end;
    end;

    if ((bking=117) and ((board[118]=3+128) or (board[119]=3+128))) or
       ((bking=118) and (board[119]=3+128)) then inc(score,TrapRook);
    if ((bking=114) and ((board[113]=3+128) or (board[112]=3+128))) or
       ((bking=113) and (board[112]=3+128)) then inc(score,TrapRook);
  end;

  kwp:=0; kbp:=0;
  kwn:=0; kbn:=0;
  kwb:=0; kbb:=0;
  kwr:=0; kbr:=0;
  kwq:=0; kbq:=0;

  wbis:=0; bbis:=0;

  if wqueen<>255 then
  begin
    inc(kwq);
    dec(score,QueenKo*rasst[wqueen,bking]);
    inc(score,EQueenW[wqueen]);
    if not(endgamW) and (vert[wqueen]=vert[bking]) then inc(score,QueenKing);
  end;
  if bqueen<>255 then
  begin
    inc(kbq);
    inc(score,QueenKo*rasst[bqueen,wking]);
    dec(score,EQueenB[bqueen]);
    if not(endgamB) and (vert[bqueen]=vert[wking]) then dec(score,QueenKing);
  end;

//  wrook:=255; brook:=255;
  wbishop:=255; bbishop:=255;

  pscore:=0; needpawn:=true;
  ind:=abs(tree[ply].pawnkey) div PHashSize;
  if ptranstable[ind].key=tree[ply].pawnkey then
  begin
    needpawn:=false;
    kwp:=ptranstable[ind].pawns;
    kbp:=kwp shr 4;
    kwp:=kwp and 15;
    pscore:=ptranstable[ind].score;
  end;

  if (needpawn) then
  begin

  for i:=0 to 7 do
  begin
    wpawn[i]:=0;
    bpawn[i]:=0;
    wpawnmin[i]:=0;
    wpawnmax[i]:=7;
    bpawnmin[i]:=7;
    bpawnmax[i]:=0;
  end;

  for i:=0 to 119 do
    if ((i and 136)=0) and (board[i]<>0) then
    begin
      if (board[i] and 64)<>0 then
      begin
        case board[i] and 7 of
        3: begin
             inc(kwr);
             inc(score,ERookW[i]);
             if not(endgamW) then
             begin
               if vert[i]=vert[bking] then inc(score,RookKing);
               if bqueen<>255 then
                 if vert[i]=vert[bqueen] then inc(score,RookQueen);
               if (hor[i]=6) and (hor[bking]=7) then inc(score,RookOn7);
               if (hor[i]=5) and (hor[bking]>5) then inc(score,RookOn6);
             end;
             mob:=0;
             wrook:=i+16;
             while ((wrook and 136)=0) and (Board[wrook]=0) do
             begin
               inc(mob);
               wrook:=wrook+16;
             end;
             wrook:=i-16;
             while ((wrook and 136)=0) and (Board[wrook]=0) do
             begin
               inc(mob);
               wrook:=wrook-16;
             end;
             inc(score,mob*RookMobileV);
             mob:=0;
             wrook:=i+1;
             while ((wrook and 136)=0) and (Board[wrook]=0) do
             begin
               inc(mob);
               wrook:=wrook+1;
             end;
             wrook:=i-1;
             while ((wrook and 136)=0) and (Board[wrook]=0) do
             begin
               inc(mob);
               wrook:=wrook-1;
             end;
             inc(score,mob*RookMobileH);
           end;
        4: begin
             inc(kwb);
             wbis:=i;
             inc(score,EBishopW[i]);
             if wbishop<>255 then inc(score,TwoBishops);
             mob:=0;
             wbishop:=i+15;
             while ((wbishop and 136)=0) and (Board[wbishop]=0) do
             begin
               inc(mob);
               wbishop:=wbishop+15;
             end;
             wbishop:=i-15;
             while ((wbishop and 136)=0) and (Board[wbishop]=0) do
             begin
               inc(mob);
               wbishop:=wbishop-15;
             end;
             wbishop:=i+17;
             while ((wbishop and 136)=0) and (Board[wbishop]=0) do
             begin
               inc(mob);
               wbishop:=wbishop+17;
             end;
             wbishop:=i-17;
             while ((wbishop and 136)=0) and (Board[wbishop]=0) do
             begin
               inc(mob);
               wbishop:=wbishop-17;
             end;
             inc(score,mob*BishopMobile);
           end;
        5: begin
             inc(kwn);
             inc(score,EKnightW[i]);
           end;
        6: begin
             inc(kwp);
             inc(pscore,EPawnW[i]);
             inc(wpawn[vert[i]]);
             if hor[i]>wpawnmax[vert[i]] then wpawnmax[vert[i]]:=hor[i];
             if hor[i]<wpawnmin[vert[i]] then wpawnmin[vert[i]]:=hor[i];
           end;
        end;
      end else
      begin
        case board[i] and 7 of
        3: begin
             inc(kbr);
             dec(score,ERookB[i]);
             if not(endgamB) then
             begin
               if vert[i]=vert[wking] then dec(score,RookKing);
               if wqueen<>255 then
                 if vert[i]=vert[wqueen] then dec(score,RookQueen);
               if (hor[i]=1) and (hor[wking]=0) then dec(score,RookOn7);
               if (hor[i]=2) and (hor[wking]<2) then dec(score,RookOn6);
             end;
             mob:=0;
             brook:=i+16;
             while ((brook and 136)=0) and (Board[brook]=0) do
             begin
               inc(mob);
               brook:=brook+16;
             end;
             brook:=i-16;
             while ((brook and 136)=0) and (Board[brook]=0) do
             begin
               inc(mob);
               brook:=brook-16;
             end;
             dec(score,mob*RookMobileV);
             mob:=0;
             brook:=i+1;
             while ((brook and 136)=0) and (Board[brook]=0) do
             begin
               inc(mob);
               brook:=brook+1;
             end;
             brook:=i-1;
             while ((brook and 136)=0) and (Board[brook]=0) do
             begin
               inc(mob);
               brook:=brook-1;
             end;
             dec(score,mob*RookMobileH);
           end;
        4: begin
             inc(kbb);
             bbis:=i;
             dec(score,EBishopB[i]);
             if bbishop<>255 then dec(score,TwoBishops);
             mob:=0;
             bbishop:=i+15;
             while ((bbishop and 136)=0) and (Board[bbishop]=0) do
             begin
               inc(mob);
               bbishop:=bbishop+15;
             end;
             bbishop:=i-15;
             while ((bbishop and 136)=0) and (Board[bbishop]=0) do
             begin
               inc(mob);
               bbishop:=bbishop-15;
             end;
             bbishop:=i+17;
             while ((bbishop and 136)=0) and (Board[bbishop]=0) do
             begin
               inc(mob);
               bbishop:=bbishop+17;
             end;
             bbishop:=i-17;
             while ((bbishop and 136)=0) and (Board[bbishop]=0) do
             begin
               inc(mob);
               bbishop:=bbishop-17;
             end;
             dec(score,mob*BishopMobile);
           end;
        5: begin
             inc(kbn);
             dec(score,EKnightB[i]);
           end;
        6: begin
             inc(kbp);
             dec(pscore,EPawnB[i]);
             inc(bpawn[vert[i]]);
             if hor[i]<bpawnmax[vert[i]] then bpawnmax[vert[i]]:=hor[i];
             if hor[i]>bpawnmin[vert[i]] then bpawnmin[vert[i]]:=hor[i];
           end;
        end;
      end;
    end;

  for i:=0 to 7 do
  begin
    if wpawn[i]>1 then dec(pscore,wpawn[i]*DoublePawn[i]);
    if bpawn[i]>1 then inc(pscore,wpawn[i]*DoublePawn[i]);

    wp:=0; bp:=0;
    if i>0 then
    begin
      if wpawn[i-1]<>0 then inc(wp);
      if bpawn[i-1]<>0 then inc(bp);
    end;
    if i<7 then
    begin
      if wpawn[i+1]<>0 then inc(wp);
      if bpawn[i+1]<>0 then inc(bp);
    end;
    if wp=0 then dec(pscore,IsolatePawn[i]);
    if bp=0 then inc(pscore,IsolatePawn[i]);

    wp:=0; bp:=0;
    if wpawnmax[i]>bpawnmin[i] then
    begin
      if i>0 then
      begin
        if wpawnmax[i]>=bpawnmin[i-1] then inc(wp);
      end else inc(wp);
      if i<7 then
      begin
        if wpawnmax[i]>=bpawnmin[i+1] then inc(wp);
      end else inc(wp);
    end;
    if bpawnmax[i]<wpawnmin[i] then
    begin
      if i>0 then
      begin
        if bpawnmax[i]<=wpawnmin[i-1] then inc(bp);
      end else inc(bp);
      if i<7 then
      begin
        if bpawnmax[i]<=wpawnmin[i+1] then inc(bp);
      end else inc(bp);
    end;
    if wp=2 then
    begin
      inc(pscore,PassPawn[wpawnmax[i]]);
    end;
    if bp=2 then
    begin
      dec(pscore,PassPawn[7-bpawnmax[i]]);
    end;
  end;

  ind:=abs(tree[ply].pawnkey) div PHashSize;
  ptranstable[ind].key:=tree[ply].pawnkey;
  ptranstable[ind].pawns:=kwp or (kbp shl 4);
  ptranstable[ind].score:=pscore;


  end else
  begin

  for i:=0 to 119 do
    if ((i and 136)=0) and (board[i]<>0) then
    begin
      if (board[i] and 64)<>0 then
      begin
        case board[i] and 7 of
        3: begin
             inc(kwr);
             inc(score,ERookW[i]);
             if not(endgamW) then
             begin
               if vert[i]=vert[bking] then inc(score,RookKing);
               if bqueen<>255 then
                 if vert[i]=vert[bqueen] then inc(score,RookQueen);
               if (hor[i]=6) and (hor[bking]=7) then inc(score,RookOn7);
               if (hor[i]=5) and (hor[bking]>5) then inc(score,RookOn6);
             end;
             mob:=0;
             wrook:=i+16;
             while ((wrook and 136)=0) and (Board[wrook]=0) do
             begin
               inc(mob);
               wrook:=wrook+16;
             end;
             wrook:=i-16;
             while ((wrook and 136)=0) and (Board[wrook]=0) do
             begin
               inc(mob);
               wrook:=wrook-16;
             end;
             inc(score,mob*RookMobileV);
             mob:=0;
             wrook:=i+1;
             while ((wrook and 136)=0) and (Board[wrook]=0) do
             begin
               inc(mob);
               wrook:=wrook+1;
             end;
             wrook:=i-1;
             while ((wrook and 136)=0) and (Board[wrook]=0) do
             begin
               inc(mob);
               wrook:=wrook-1;
             end;
             inc(score,mob*RookMobileH);
           end;
        4: begin
             inc(kwb);
             wbis:=i;
             inc(score,EBishopW[i]);
             if wbishop<>255 then inc(score,TwoBishops);
             mob:=0;
             wbishop:=i+15;
             while ((wbishop and 136)=0) and (Board[wbishop]=0) do
             begin
               inc(mob);
               wbishop:=wbishop+15;
             end;
             wbishop:=i-15;
             while ((wbishop and 136)=0) and (Board[wbishop]=0) do
             begin
               inc(mob);
               wbishop:=wbishop-15;
             end;
             wbishop:=i+17;
             while ((wbishop and 136)=0) and (Board[wbishop]=0) do
             begin
               inc(mob);
               wbishop:=wbishop+17;
             end;
             wbishop:=i-17;
             while ((wbishop and 136)=0) and (Board[wbishop]=0) do
             begin
               inc(mob);
               wbishop:=wbishop-17;
             end;
             inc(score,mob*BishopMobile);
           end;
        5: begin
             inc(kwn);
             inc(score,EKnightW[i]);
           end;
        end;
      end else
      begin
        case board[i] and 7 of
        3: begin
             inc(kbr);
             dec(score,ERookB[i]);
             if not(endgamB) then
             begin
               if vert[i]=vert[wking] then dec(score,RookKing);
               if wqueen<>255 then
                 if vert[i]=vert[wqueen] then dec(score,RookQueen);
               if (hor[i]=1) and (hor[wking]=0) then dec(score,RookOn7);
               if (hor[i]=2) and (hor[wking]<2) then dec(score,RookOn6);
             end;
             mob:=0;
             brook:=i+16;
             while ((brook and 136)=0) and (Board[brook]=0) do
             begin
               inc(mob);
               brook:=brook+16;
             end;
             brook:=i-16;
             while ((brook and 136)=0) and (Board[brook]=0) do
             begin
               inc(mob);
               brook:=brook-16;
             end;
             dec(score,mob*RookMobileV);
             mob:=0;
             brook:=i+1;
             while ((brook and 136)=0) and (Board[brook]=0) do
             begin
               inc(mob);
               brook:=brook+1;
             end;
             brook:=i-1;
             while ((brook and 136)=0) and (Board[brook]=0) do
             begin
               inc(mob);
               brook:=brook-1;
             end;
             dec(score,mob*RookMobileH);
           end;
        4: begin
             inc(kbb);
             bbis:=i;
             dec(score,EBishopB[i]);
             if bbishop<>255 then dec(score,TwoBishops);
             mob:=0;
             bbishop:=i+15;
             while ((bbishop and 136)=0) and (Board[bbishop]=0) do
             begin
               inc(mob);
               bbishop:=bbishop+15;
             end;
             bbishop:=i-15;
             while ((bbishop and 136)=0) and (Board[bbishop]=0) do
             begin
               inc(mob);
               bbishop:=bbishop-15;
             end;
             bbishop:=i+17;
             while ((bbishop and 136)=0) and (Board[bbishop]=0) do
             begin
               inc(mob);
               bbishop:=bbishop+17;
             end;
             bbishop:=i-17;
             while ((bbishop and 136)=0) and (Board[bbishop]=0) do
             begin
               inc(mob);
               bbishop:=bbishop-17;
             end;
             dec(score,mob*BishopMobile);
           end;
        5: begin
             inc(kbn);
             dec(score,EKnightB[i]);
           end;
        end;
      end;
    end;

  end;

  inc(score,pscore);
//  score:=score div 2;
  inc(score,matscore);

  wfig:=kwp+kwn+kwb+kwr+kwq;
  bfig:=kbp+kbn+kbb+kbr+kbq;

  if wfig=0 then
  begin
    if (kbq>0) or (kbr>0) or (kbb>1) or ((kbb>0) and (kbn>0)) then dec(score,1000);
    if (kbq>0) or (kbr>0) then dec(score,BN_dark[wking]);
    if (kbb>1) then dec(score,BN_dark[wking]);
    if (kbb>0) and (kbn>0) then
    begin
      if dark_sq[bbis]=1 then dec(score,5*BN_dark[wking])
      else dec(score,5*BN_light[wking]);
    end;
    if ((bfig=1) and (kbn>0)) or ((bfig=1) and (kbb>0)) or ((bfig=2) and (kbn>1)) then score:=0;
  end;

  if bfig=0 then
  begin
    if (kwq>0) or (kwr>0) or (kwb>1) or ((kwb>0) and (kwn>0)) then inc(score,1000);
    if (kwq>0) or (kwr>0) then inc(score,BN_light[bking]);
    if (kwb>1) then inc(score,BN_light[bking]);
    if (kwb>0) and (kwn>0) then
    begin
      if dark_sq[wbis]=1 then inc(score,5*BN_dark[bking])
      else inc(score,5*BN_light[bking]);
    end;
    if ((wfig=1) and (kwn>0)) or ((wfig=1) and (kwb>0)) or ((wfig=2) and (kwn>1)) then score:=0;
  end;

  if (bfig=1) and (wfig=1) then
  begin
    if ((kwn>0) or (kwb>0)) and ((kbn>0) or (kbb>0)) then score:=0;
    if ((kwr>0) and ((kbn>0) or (kbb>0)))
        or ((kbr>0) and ((kwn>0) or (kwb>0))) then score:=score div 10;
    if ((kbn>0) or (kbb>0)) and (kwp>0) then score:=score div 10;
    if ((kwn>0) or (kwb>0)) and (kbp>0) then score:=score div 10;
  end;

  if ((bfig=2) and (wfig=1)) or ((wfig=2) and (bfig=1)) then
  begin
    if (kwq=0) and (kwr=0) and (kwp=0)
        and (kbq=0) and (kbr=0) and (kbp=0) then score:=score div 10;
    if (kwp=2) and ((kbn>0) or (kbb>0)) then score:=score div 10;
    if (kbp=2) and ((kwn>0) or (kwb>0)) then score:=score div 10;
    if (kwn=2) and ((kwn>0) or (kwb>0) or (kwr>0)) then score:=score div 10;
    if (kbn=2) and ((kbn>0) or (kbb>0) or (kbr>0)) then score:=score div 10;
  end;

  if (bfig=3) and (wfig=1) then
  begin
    if (kbp=3) and ((kwn>0) or (kwb>0)) then score:=score div 10;
  end;

  if (wfig=3) and (bfig=1) then
  begin
    if (kwp=3) and ((kbn>0) or (kbb>0)) then score:=score div 10;
  end;

  if (wfig=2) and (bfig=2) then
  begin
    if (kwn=2) and ((kbn>0) or (kbb>0)) and (kbp=1) then score:=score div 10;
    if (kbn=2) and ((kwn>0) or (kwb>0)) and (kwp=1) then score:=score div 10;
  end;

  if (wfig=3) and (bfig=2) then
  begin
    if (kbn=2) and ((kwn>0) or (kwb>0)) and (kwp=2) then score:=score div 10;
  end;

  if (wfig=2) and (bfig=3) then
  begin
    if (kwn=2) and ((kbn>0) or (kbb>0)) and (kbp=2) then score:=score div 10;
  end;

  if (wfig=4) and (bfig=2) then
  begin
    if (kbn=2) and (kwn>0) and (kwp=3) then score:=score div 10;
  end;

  if (wfig=2) and (bfig=4) then
  begin
    if (kwn=2) and (kbn>0) and (kbp=3) then score:=score div 10;
  end;
  
  if tree[ply].tomove=0 then result:=score
  else result:=-score;
end;

end.
