unit tests;

interface

uses param, fen, genmoves, genkills, eval, attack, util, sysutils, movemake, sortmoves;

procedure test;
procedure test2(d:byte; s:string);
procedure ggtest(depth,ply:byte);

var testnodes:int64;

implementation

procedure test2(d:byte; s:string);
//  
var i:integer;
    testNPS:real;
    tim:longint;
begin
  readfen(s);
  testNPS:=0;
  HistoryInit;
  for i:=1 to d do
  begin
    testnodes:=0;
    StartTimer;
    ggtest(i,0);
    tim:=gettimer;
    if tim>0 then testNPS:=1000*(testnodes/tim);
    writeln('Depth='+inttostr(i)+' Nodes='+inttostr(testnodes)+' Time='+floattostr(tim/1000)+' NPS='+floattostr(testNPS));
//    ShowBoard;
  end;
end;

procedure ggtest(depth,ply:byte);
//  
var i,k,kk,mo:integer;
begin
  CopyTree(ply,ply+1);
  movegen(ply);
  killgen(ply+1);
//  SortLegal(ply);
//  SortInit(ply);
  k:=0; kk:=tree[ply+1].movenum;
{  if testnodes=60 then
  begin
    showboard;
  end;}
  for i:=300*ply+1 to 300*ply+tree[ply].movenum do
  begin
//    mo:=moves[sortm[1,i]];
    mo:=Moves[i];
    if (mo shr 16)<>0 then inc(k);
{    for j:=300*(ply+1)+1 to 300*(ply+1)+kk do
      if mo=Moves[j] then inc(k);}
    if depth=1 then
    begin
//      if makemove_q(moves[i],ply) then
      if makemove_simple(mo,ply) then
      begin
        inc(testnodes);
        unmakemove(mo,ply);
      end;
    end else
    begin
      if makemove(mo,ply) then
      begin
        ggtest(depth-1,ply+1);
        unmakemove(mo,ply);
      end;
    end;
  end;
  
  if k<>kk then
  begin
    showboard;
    writeln(ply,': ',k,'/',kk);
  end;
end;

procedure test;
var c,i,tim:integer;
    s:string;
begin
  c:=5000000;
  readfen('rnbqkbnr/8/8/8/8/8/8/RNBQKBNR w KQkq - 0 1');
  StartTimer;
  for i := 1 to c do
  begin
//    attacked(tree[0].tomove,0,255);
//    tree[0].movenum:=killgen(0);
    movegen(0);
//    sortf(tree[0].movenum,0);
//    evalution(0,0);
  end;
  Tim:=GetTimer;
  lprint(inttostr(tim)+' '+floattostr(1000*(c/tim)));
  s:='';
  for i:=1 to tree[0].movenum do
  begin
    s:=s+koord[moves[i] and 255];
    s:=s+koord[(moves[i] shr 8) and 255];
    s:=s+' ';
  end;
  lprint(s);
  if attacked(tree[0].tomove,0,255) then lprint('1') else lprint('0');
  if attacked(1-tree[0].tomove,0,255) then lprint('1') else lprint('0');
end;

end.
